% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% Ph.D. Course "Intelligence for Embedded Systems"
% Prof. Manuel Roveri
% Politecnico di Milano, Italy
% Jan, 2015
% 
% ----- "Uncertainty, Information and Learning Mechanisms - Part 1"
% -> Example 3_1_A) Projection and Truncation of Natural Numbers
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clc
clear
close all

% Number of Samples
n_samples = 10000;

% Number of bits
n_bits = 10;

% Number of bits for truncation
q = 4;


%% MAIN %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
random_numbers = randi(2^n_bits-1,n_samples,1);
random_binaries = dec2bin(random_numbers);

% This is to manage the case that random_binaries is not on n_bits bits
n = size(random_binaries,2);

projected_binaries = random_binaries;

%% Projection
projected_binaries(:,n-q+1:n) = '0';
projected_numbers = bin2dec(projected_binaries);

proj_error = random_numbers - projected_numbers;
proj_max = max(proj_error);
proj_min = min(proj_error);
figure();
hist(proj_error,2^q);
title('Histograms of the error with PROJECTION');
fprintf('\n PROJECTION \n');
fprintf('Expected %f and estimated %f mean\n',(2^q-1) / 2, mean(proj_error));
fprintf('Expected %f and estimated %f variance\n',2^(2*(q-1)) / 3, var(proj_error));

%% Truncation
truncated_binaries = projected_binaries(:,1:n-q);
truncated_numbers = bin2dec(truncated_binaries);

trunc_error = random_numbers - truncated_numbers * 2^q;
trunc_max = max(trunc_error);
trunc_min = min(trunc_error);
figure();
hist(trunc_error,2^q);
title('Histograms of the error with TRUNCATION');
fprintf('\n TRUNCATION \n');
fprintf('Expected %f and estimated %f mean\n',(2^q-1) / 2, mean(trunc_error));
fprintf('Expected %f and estimated %f variance\n',2^(2*(q-1)) / 3, var(trunc_error));
